summaryrefslogtreecommitdiff
authorkergoth <kergoth>2002-08-29 19:57:13 (UTC)
committer kergoth <kergoth>2002-08-29 19:57:13 (UTC)
commit598b2f4c404c2e12f59c2abc765f58bb8d0862a3 (patch) (unidiff)
treecbf2e207033ca7afdd4aa3368b919000f79fe78d
parent4b864b9a6509d3b43be34d39264a9c23f5240641 (diff)
downloadopie-598b2f4c404c2e12f59c2abc765f58bb8d0862a3.zip
opie-598b2f4c404c2e12f59c2abc765f58bb8d0862a3.tar.gz
opie-598b2f4c404c2e12f59c2abc765f58bb8d0862a3.tar.bz2
We use new ipk format now.
Diffstat (more/less context) (ignore whitespace changes)
-rwxr-xr-xmkipks35
-rwxr-xr-xscripts/ipkg-build194
-rwxr-xr-xscripts/ipkg-unbuild29
3 files changed, 241 insertions, 17 deletions
diff --git a/mkipks b/mkipks
index 21b903c..26c72b9 100755
--- a/mkipks
+++ b/mkipks
@@ -30,8 +30,8 @@ STRIP=arm-linux-strip
30STRIP_FILES="*ARM*not stripped" 30STRIP_FILES="*ARM*not stripped"
31 31
32TDIR=/tmp/ipk$$ 32TDIR=/tmp/ipk$$
33DATADIR=$TDIR/data 33DATADIR=$TDIR
34CTRLDIR=$TDIR/control 34CTRLDIR=$TDIR/CONTROL
35 35
36IMAGEDIR= 36IMAGEDIR=
37VERB= 37VERB=
@@ -187,16 +187,23 @@ do
187 elif [ -z "$IMAGEDIR" ] 187 elif [ -z "$IMAGEDIR" ]
188 then 188 then
189 #size=$(du -h -s $DATADIR | sed -e 's/[ ].*//') 189 #size=$(du -h -s $DATADIR | sed -e 's/[ ].*//')
190 size=$(mkfs.jffs2 -r $DATADIR | wc -c) 190 if (which mkfs.jffs2 >/dev/null 2>&1); then
191 size=$(mkfs.jffs2 -r $DATADIR | wc -c)
192 fi
191 echo "Package: $packagename" >$CTRLDIR/control 193 echo "Package: $packagename" >$CTRLDIR/control
194 if [ ! -z "$size" ]; then
192 echo "Installed-Size: $size" >>$CTRLDIR/control 195 echo "Installed-Size: $size" >>$CTRLDIR/control
196 else
197 echo "Warning, no mkfs.jffs2 found, unable to set Installed-Size."
198 fi
199 echo "Architecture: $ARCH" >>$CTRLDIR/control
193 echo "Filename: ./$package.ipk" >>$CTRLDIR/control 200 echo "Filename: ./$package.ipk" >>$CTRLDIR/control
194 echo "Version: $version" >>$CTRLDIR/control 201 echo "Version: $version" >>$CTRLDIR/control
195 echo "Depends: $depends" >>$CTRLDIR/control 202 [ ! -z "$depends" ] && echo "Depends: $depends" >>$CTRLDIR/control
196 echo "Provides: $provides" >>$CTRLDIR/control 203 [ ! -z "$provides" ] && echo "Provides: $provides" >>$CTRLDIR/control
197 echo "Conflicts: $conflicts" >>$CTRLDIR/control 204 [ ! -z "$conflicts" ] && echo "Conflicts: $conflicts" >>$CTRLDIR/control
198 egrep -v "^(Files|Version|Depends|Provides|Conflicts):" >>$CTRLDIR/control $i 205 egrep -v "^(Files|Version|Depends|Provides|Conflicts|Architecture):" >>$CTRLDIR/control $i
199 echo "$DEB_VERSION" >$TDIR/debian-binary 206 # echo "$DEB_VERSION" >$TDIR/debian-binary
200 base=${i%.control} 207 base=${i%.control}
201 scripts="preinst postinst prerm postrm" 208 scripts="preinst postinst prerm postrm"
202 for pf in $scripts 209 for pf in $scripts
@@ -206,15 +213,7 @@ do
206 cp ${base}.$pf $CTRLDIR/$pf 213 cp ${base}.$pf $CTRLDIR/$pf
207 fi 214 fi
208 done 215 done
209 if [ "$UID" = 0 ] 216 $OPIEDIR/scripts/ipkg-build -o root -g root $TDIR
210 then
211 chown -R root.root $TDIR
212 else
213 echo "Warning: You are not root. Unable to squash permissions."
214 fi
215 ( cd $CTRLDIR; tar cfz ../control.tar.gz ./*; )
216 ( cd $DATADIR; tar cfz ../data.tar.gz ./*; )
217 ( cd $TDIR; rm -rf control data; tar cf - ./debian-binary ./control.tar.gz ./data.tar.gz; ) | gzip >$RDIR/$package.ipk
218 RESULT=$package.ipk 217 RESULT=$package.ipk
219 if [ -n "$VERB" ] 218 if [ -n "$VERB" ]
220 then 219 then
@@ -229,3 +228,5 @@ do
229 echo >&2 "Not building $package package" 228 echo >&2 "Not building $package package"
230 fi 229 fi
231done 230done
231# clean up
232rm -rf $TDIR
diff --git a/scripts/ipkg-build b/scripts/ipkg-build
new file mode 100755
index 0000000..ac8f286
--- a/dev/null
+++ b/scripts/ipkg-build
@@ -0,0 +1,194 @@
1#!/bin/bash
2
3# ipkg-build -- construct a .ipk from a directory
4# Carl Worth <cworth@east.isi.edu>
5# based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001
6set -e
7
8ipkg_extract_value() {
9 sed -e "s/^[^:]*:[[:space:]]*//"
10}
11
12required_field() {
13 field=$1
14
15 value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value`
16 if [ -z "$value" ]; then
17 echo "*** Error: $CONTROL/control is missing field $field" >&2
18 return 1
19 fi
20 echo $value
21 return 0
22}
23
24pkg_appears_sane() {
25 local pkg_dir=$1
26
27 local owd=`pwd`
28 cd $pkg_dir
29
30 PKG_ERROR=0
31
32 tilde_files=`find . -name '*~'`
33 if [ -n "$tilde_files" ]; then
34 echo "*** Warning: The following files have names ending in '~'.
35You probably want to remove them: " >&2
36 ls -ld $tilde_files
37 echo >&2
38 fi
39
40 large_uid_files=`find . -uid +99`
41
42 if [ "$ogargs" = "" ] && [ -n "$large_uid_files" ]; then
43 echo "*** Warning: The following files have a UID greater than 99.
44You probably want to chown these to a system user: " >&2
45 ls -ld $large_uid_files
46 echo >&2
47 fi
48
49
50 if [ ! -f "$CONTROL/control" ]; then
51 echo "*** Error: Control file $pkg_dir/$CONTROL/control not found." >&2
52 cd $owd
53 return 1
54 fi
55
56 pkg=`required_field Package`
57 [ "$?" -ne 0 ] && PKG_ERROR=1
58
59 version=`required_field Version | sed 's/.*://;'`
60 [ "$?" -ne 0 ] && PKG_ERROR=1
61
62 arch=`required_field Architecture`
63 [ "$?" -ne 0 ] && PKG_ERROR=1
64
65 required_field Maintainer >/dev/null
66 [ "$?" -ne 0 ] && PKG_ERROR=1
67
68 required_field Description >/dev/null
69 [ "$?" -ne 0 ] && PKG_ERROR=1
70
71 section=`required_field Section`
72 [ "$?" -ne 0 ] && PKG_ERROR=1
73 if [ -z "$section" ]; then
74 echo "The Section field should have one of the following values:" >&2
75 echo "admin, base, comm, editors, extras, games, graphics, kernel, libs, misc, net, text, web, x11" >&2
76 fi
77
78 priority=`required_field Priority`
79 [ "$?" -ne 0 ] && PKG_ERROR=1
80 if [ -z "$priority" ]; then
81 echo "The Priority field should have one of the following values:" >&2
82 echo "required, important, standard, optional, extra." >&2
83 echo "If you don't know which priority value you should be using, then use \`optional'" >&2
84 fi
85
86 if echo $pkg | grep '[^a-z0-9.+-]'; then
87 echo "*** Error: Package name $name contains illegal characters, (other than [a-z0-9.+-])" >&2
88 PKG_ERROR=1;
89 fi
90
91 local bad_fields=`sed -ne 's/^\([^[:space:]][^:[:space:]]\+[[:space:]]\+\)[^:].*/\1/p' < $CONTROL/control | sed -e 's/\\n//'`
92 if [ -n "$bad_fields" ]; then
93 bad_fields=`echo $bad_fields`
94 echo "*** Error: The following fields in $CONTROL/control are missing a ':'" >&2
95 echo "$bad_fields" >&2
96 echo "ipkg-build: This may be due to a missing initial space for a multi-line field value" >&2
97 PKG_ERROR=1
98 fi
99
100 for script in $CONTROL/preinst $CONTROL/postinst $CONTROL/prerm $CONTROL/postrm; do
101 if [ -f $script -a ! -x $script ]; then
102 echo "*** Error: package script $script is not executable" >&2
103 PKG_ERROR=1
104 fi
105 done
106
107 if [ -f $CONTROL/conffiles ]; then
108 for cf in `cat $CONTROL/conffiles`; do
109 if [ ! -f ./$cf ]; then
110 echo "*** Error: $CONTROL/conffiles mentions conffile $cf which does not exist" >&2
111 PKG_ERROR=1
112 fi
113 done
114 fi
115
116 cd $owd
117 return $PKG_ERROR
118}
119
120###
121# ipkg-build "main"
122###
123ogargs=""
124usage="Usage: $0 [-o owner] [-g group] <pkg_directory> [<destination_directory>]"
125while getopts ":o:g:" opt; do
126 case $opt in
127 o ) owner=$OPTARG
128 ogargs="--owner=$owner"
129 ;;
130 g ) group=$OPTARG
131 ogargs="$ogargs --group=$group"
132 ;;
133 \? ) echo $usage >&2
134 esac
135done
136
137
138shift $(($OPTIND - 1))
139
140# continue on to process additional arguments
141
142case $# in
1431)
144 dest_dir=.
145 ;;
1462)
147 dest_dir=$2
148 ;;
149*)
150 echo echo $usage >&2
151 exit 1
152 ;;
153esac
154
155pkg_dir=$1
156
157if [ ! -d $pkg_dir ]; then
158 echo "*** Error: Directory $pkg_dir does not exist" >&2
159 exit 1
160fi
161
162# CONTROL is second so that it takes precedence
163CONTROL=
164[ -d $pkg_dir/DEBIAN ] && CONTROL=DEBIAN
165[ -d $pkg_dir/CONTROL ] && CONTROL=CONTROL
166if [ -z "$CONTROL" ]; then
167 echo "*** Error: Directory $pkg_dir has no CONTROL subdirectory." >&2
168 exit 1
169fi
170
171if ! pkg_appears_sane $pkg_dir; then
172 echo >&2
173 echo "ipkg-build: Please fix the above errors and try again." >&2
174 exit 1
175fi
176
177tmp_dir=$dest_dir/IPKG_BUILD.$$
178mkdir $tmp_dir
179
180tar $ogargs -C $pkg_dir -czf $tmp_dir/data.tar.gz . --exclude=$CONTROL
181tar $ogargs -C $pkg_dir/$CONTROL -czf $tmp_dir/control.tar.gz .
182
183echo "2.0" > $tmp_dir/debian-binary
184
185pkg_file=$dest_dir/${pkg}_${version}_${arch}.ipk
186here_dir=$PWD
187## tar -C $tmp_dir -czf $pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz
188rm -f $pkg_file
189cd $tmp_dir ; ar crf $here_dir/$pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz
190cd $here_dir
191rm $tmp_dir/debian-binary $tmp_dir/data.tar.gz $tmp_dir/control.tar.gz
192rmdir $tmp_dir
193
194echo "Packaged contents of $pkg_dir into $pkg_file"
diff --git a/scripts/ipkg-unbuild b/scripts/ipkg-unbuild
new file mode 100755
index 0000000..f724f75
--- a/dev/null
+++ b/scripts/ipkg-unbuild
@@ -0,0 +1,29 @@
1#!/bin/sh
2
3set -e
4
5if [ $# -lt 1 ]; then
6 echo "usage: $0: package.ipk"
7 exit 1
8fi
9
10while [ $# -gt 0 ]; do
11 filename=$1
12 shift
13
14 pkg=`echo $filename | sed 's/.*\///;s/.ipk$//;s/.deb$//'`
15
16 mkdir -p $pkg
17 mkdir -p $pkg/CONTROL
18
19 pkg_dir=$PWD
20 cd $pkg; (ar x ../$filename || tar zxf ../$filename) >& /dev/null
21 cd $pkg_dir
22
23 tar xzf $pkg/data.tar.gz -C $pkg
24 tar xzf $pkg/control.tar.gz -C $pkg/CONTROL
25 rm -f $pkg/control.tar.gz $pkg/data.tar.gz $pkg/debian-binary
26done
27
28
29